Attribute VB_Name = "RegistryStuff"
Option Explicit

Private Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long
Private Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long
Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Private Declare Function RegSetValueExString Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, ByVal lpValue As String, ByVal cbData As Long) As Long
Private Declare Function RegSetValueExLong Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, lpValue As Long, ByVal cbData As Long) As Long

Private Const ERROR_SUCCESS = 0&

Public Const HKEY_CLASSES_ROOT = &H80000000
Public Const HKEY_CURRENT_USER = &H80000001
Public Const HKEY_LOCAL_MACHINE = &H80000002
Public Const HKEY_USERS = &H80000003

Private Const STANDARD_RIGHTS_ALL = &H1F0000
Private Const KEY_QUERY_VALUE = &H1
Private Const KEY_SET_VALUE = &H2
Private Const KEY_CREATE_SUB_KEY = &H4
Private Const KEY_ENUMERATE_SUB_KEYS = &H8
Private Const KEY_NOTIFY = &H10
Private Const KEY_CREATE_LINK = &H20
Private Const SYNCHRONIZE = &H100000
Private Const KEY_ALL_ACCESS = _
    ((STANDARD_RIGHTS_ALL Or _
    KEY_QUERY_VALUE Or _
    KEY_SET_VALUE Or _
    KEY_CREATE_SUB_KEY Or _
    KEY_ENUMERATE_SUB_KEYS Or _
    KEY_NOTIFY Or KEY_CREATE_LINK) And _
    (Not SYNCHRONIZE))

Public Const REG_SZ As Long = 1
Public Const REG_DWORD As Long = 4

' Return a registry value.
Private Function GetRegistryValue(ByVal registry_section As Long, ByVal key_name As String, ByVal subkey_name As String) As String
Dim hKey As Long
Dim value As String
Dim length As Long
Dim value_type As Long

    ' Assume there will be trouble.
    GetRegistryValue = "???"

    ' Open the key.
    If RegOpenKeyEx(registry_section, _
        key_name, 0&, KEY_ALL_ACCESS, hKey) <> ERROR_SUCCESS _
            Then Exit Function

    ' Get the subkey's value.
    length = 1024
    value = Space$(length)
    If RegQueryValueEx(hKey, subkey_name, _
        0&, value_type, ByVal value, length) _
            <> ERROR_SUCCESS _
                    Then Exit Function

    ' Remove the trailing null character.
    GetRegistryValue = Left$(value, length - 1)

    ' Close the key.
    RegCloseKey hKey
End Function

' Set a String or Long registry value. Return True if there's a problem.
Public Function SetRegistryValue(ByVal registry_section As Long, ByVal key_name As String, ByVal value_name As String, ByVal value As Variant) As Boolean
Dim hKey As Long

    ' Assume there will be a problem.
    SetRegistryValue = True

    ' Open the key.
    If RegOpenKeyEx(registry_section, _
        key_name, 0&, KEY_SET_VALUE, hKey) <> ERROR_SUCCESS _
            Then Exit Function

    ' Set the value.
    If VarType(value) = vbString Then
        If RegSetValueExString(hKey, value_name, 0&, REG_SZ, _
            value, Len(value)) <> ERROR_SUCCESS Then Exit Function
    ElseIf VarType(value) = vbLong Then
        If RegSetValueExLong(hKey, value_name, 0&, REG_DWORD, _
            value, Len(value)) <> ERROR_SUCCESS Then Exit Function
    Else
        ' We don't know how to handle this type.
        Exit Function
    End If

    ' Close the key.
    RegCloseKey hKey

    ' Return a success code.
    SetRegistryValue = False
End Function
